## org.apache.poi.xwpf.usermodel
Class XWPFFootnotes

    java.lang.Object
      org.apache.poi.POIXMLDocumentPart
          org.apache.poi.xwpf.usermodel.XWPFFootnotes

    public class XWPFFootnotes

extends POIXMLDocumentPart

Looks after the collection of Footnotes for a document

Author:
  Mike McEuen (mceuen@hp.com)

Field Summary
`protected XWPFDocument` `document`

Fields inherited from class org.apache.poi.POIXMLDocumentPart
`DEFAULT_XML_OPTIONS`

Constructor Summary
`XWPFFootnotes()` Construct XWPFFootnotes from scratch for a new document.
`XWPFFootnotes(PackagePart part, PackageRelationship rel)` Construct XWPFFootnotes from a package part

Method Summary
`XWPFFootnote` `addFootnote(org.openxmlformats.schemas.wordprocessingml.x2006.main.CTFtnEdn note)` add a footnote to the document
`void` `addFootnote(XWPFFootnote footnote)` add an XWPFFootnote to the document
`protected void` `commit()` Save the content in the underlying package part.
`XWPFFootnote` `getFootnoteById(int id)`
`java.util.List<XWPFFootnote>` `getFootnotesList()`
`XWPFDocument` `getXWPFDocument()`
`protected void` `onDocumentRead()` Read document
`void` `setFootnotes(org.openxmlformats.schemas.wordprocessingml.x2006.main.CTFootnotes footnotes)` Sets the ctFootnotes
`void` `setXWPFDocument(XWPFDocument doc)`

Methods inherited from class org.apache.poi.POIXMLDocumentPart
`addRelation, createRelationship, createRelationship, createRelationship, getPackagePart, getPackageRelationship, getParent, getRelationById, getRelationId, getRelations, getTargetPart, onDocumentCreate, onDocumentRemove, onSave, read, rebase, removeRelation, removeRelation, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### document

    protected XWPFDocument document

Constructor Detail

### XWPFFootnotes

    public XWPFFootnotes(PackagePart part,
                         PackageRelationship rel)
                  throws java.io.IOException,
                         OpenXML4JException

  Construct XWPFFootnotes from a package part

  Parameters:
    `part` - the package part holding the data of the footnotes,
    `rel` - the package relationship of type "http://schemas.openxmlformats.org/officeDocument/2006/relationships/footnotes"
  Throws:
    `java.io.IOException`
    `OpenXML4JException`

### XWPFFootnotes

    public XWPFFootnotes()

  Construct XWPFFootnotes from scratch for a new document.

Method Detail

### onDocumentRead

    protected void onDocumentRead()
                           throws java.io.IOException

  Read document

  Overrides:
    `onDocumentRead` in class `POIXMLDocumentPart`
  Throws:
    `java.io.IOException`

### commit

    protected void commit()
                   throws java.io.IOException

  Description copied from class: `POIXMLDocumentPart`
  Save the content in the underlying package part. Default implementation is empty meaning that the package part is left unmodified. Sub-classes should override and add logic to marshal the "model" into Ooxml4J. For example, the code saving a generic XML entry may look as follows:

       protected void commit() throws IOException {
         PackagePart part = getPackagePart();
         OutputStream out = part.getOutputStream();
         XmlObject bean = getXmlBean(); //the "model" which holds changes in memory
         bean.save(out, DEFAULT_XML_OPTIONS);
         out.close();
       }

  Overrides:
    `commit` in class `POIXMLDocumentPart`
  Throws:
    `java.io.IOException`

### getFootnotesList

    public java.util.List<XWPFFootnote> getFootnotesList()

### getFootnoteById

    public XWPFFootnote getFootnoteById(int id)

### setFootnotes

    public void setFootnotes(org.openxmlformats.schemas.wordprocessingml.x2006.main.CTFootnotes footnotes)

  Sets the ctFootnotes

  Parameters:
    `footnotes` -

### addFootnote

    public void addFootnote(XWPFFootnote footnote)

  add an XWPFFootnote to the document

  Parameters:
    `footnote` -
  Throws:
    `java.io.IOException`

### addFootnote

    public XWPFFootnote addFootnote(org.openxmlformats.schemas.wordprocessingml.x2006.main.CTFtnEdn note)

  add a footnote to the document

  Parameters:
    `note` -
  Throws:
    `java.io.IOException`

### setXWPFDocument

    public void setXWPFDocument(XWPFDocument doc)

### getXWPFDocument

    public XWPFDocument getXWPFDocument()

  See Also:
    `IBody.getPart()`

Copyright 2012 The Apache Software Foundation or its licensors, as applicable.